import math
import time
import random

import pygame
pygame.init()

screen = pygame.display.set_mode((1000,1000))

timeResolution=.1;
timeDeath=100;
trailLength=300;
velocityScale=10;
accelScale=3;


class Particle:
    def __init__(self,initial_position, initial_velocity, acceleration, endPoint):
        self.initial_position = initial_position
        self.initial_velocity = initial_velocity
        self.acceleration = acceleration
        self.time=0;
        self.endpoint=endPoint;
        self.current_position=self.initial_position
        self.color=(random.randint(64,255), random.randint(64,255), random.randint(64,255))
        self.positions=[initial_position,initial_position];
        self.positionFuzz=(random.randint(0,1000),random.randint(0,1000))
        self.deathFlag=False;
        

    def position(self, time):
        x = self.initial_position[0] + self.initial_velocity[0]*time + 0.5*self.acceleration[0]*time**2
        y = self.initial_position[1] + self.initial_velocity[1]*time + 0.5*self.acceleration[1]*time**2
        return (x,y)

    def getDisplayPosition(self):
        return((self.current_position[0]+500,self.current_position[1]+500));
    
    def lerp(self, p1, p2, t):
        x = (1 - t) * p1[0] + t * p2[0]
        y = (1 - t) * p1[1] + t * p2[1]
        #print(t)
        return (x, y)
    
    def update(self):
        global timeResolution, timeDeath;
        #self.endpoint=(pygame.mouse.get_pos()[0]+self.positionFuzz[0],pygame.mouse.get_pos()[1]+self.positionFuzz[1]);
        self.time=self.time+timeResolution;
        if(not self.deathFlag): #if we are not dead, update. Otherwise, keep the previous value.
            self.current_position=self.lerp(self.position(self.time),self.positionFuzz,(self.time/timeDeath));
        self.positions.append(self.current_position);
        if(self.time>timeDeath):
            self.deathFlag=True;
        if(len(self.positions)>trailLength):#trim the list so it doesnt get too long.
            self.positions.pop(0);
            

    

particleList=[];
 

frame=0;
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            done = True
        elif event.type == pygame.MOUSEBUTTONDOWN:
            # Get mouse position
            particleList.append(Particle(pygame.mouse.get_pos(),(random.random()-.5,random.random()-.5),(random.random()-.5,random.random()-.5),pygame.mouse.get_pos()))   


    # Clear screen
    screen.fill((0, 0, 0))

    # Draw point on screen
    for a in particleList:
        a.update();

        #draw the trail)
        pygame.draw.lines(screen, a.color,False, a.positions,2)
        #pygame.draw.circle(screen, a.color, a.current_position, 2)
        #print("drawing the point", a.getDisplayPosition());
        if(a.time-trailLength>timeDeath and a.deathFlag):
            particleList.remove(a);
            del a;
           
    #if(frame%120==0):
     #       frame=frame+1;
    # Update display
    pygame.display.flip()
    
